/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WebPushSubscriptionDataKeys type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WebPushSubscriptionDataKeys{}

// WebPushSubscriptionDataKeys struct for WebPushSubscriptionDataKeys
type WebPushSubscriptionDataKeys struct {
	Auth string `json:"auth"`
	P256dh string `json:"p256dh"`
}

// NewWebPushSubscriptionDataKeys instantiates a new WebPushSubscriptionDataKeys object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWebPushSubscriptionDataKeys(auth string, p256dh string) *WebPushSubscriptionDataKeys {
	this := WebPushSubscriptionDataKeys{}
	this.Auth = auth
	this.P256dh = p256dh
	return &this
}

// NewWebPushSubscriptionDataKeysWithDefaults instantiates a new WebPushSubscriptionDataKeys object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWebPushSubscriptionDataKeysWithDefaults() *WebPushSubscriptionDataKeys {
	this := WebPushSubscriptionDataKeys{}
	return &this
}

// GetAuth returns the Auth field value
func (o *WebPushSubscriptionDataKeys) GetAuth() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Auth
}

// GetAuthOk returns a tuple with the Auth field value
// and a boolean to check if the value has been set.
func (o *WebPushSubscriptionDataKeys) GetAuthOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Auth, true
}

// SetAuth sets field value
func (o *WebPushSubscriptionDataKeys) SetAuth(v string) {
	o.Auth = v
}

// GetP256dh returns the P256dh field value
func (o *WebPushSubscriptionDataKeys) GetP256dh() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.P256dh
}

// GetP256dhOk returns a tuple with the P256dh field value
// and a boolean to check if the value has been set.
func (o *WebPushSubscriptionDataKeys) GetP256dhOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.P256dh, true
}

// SetP256dh sets field value
func (o *WebPushSubscriptionDataKeys) SetP256dh(v string) {
	o.P256dh = v
}

func (o WebPushSubscriptionDataKeys) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WebPushSubscriptionDataKeys) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["auth"] = o.Auth
	toSerialize["p256dh"] = o.P256dh
	return toSerialize, nil
}

type NullableWebPushSubscriptionDataKeys struct {
	value *WebPushSubscriptionDataKeys
	isSet bool
}

func (v NullableWebPushSubscriptionDataKeys) Get() *WebPushSubscriptionDataKeys {
	return v.value
}

func (v *NullableWebPushSubscriptionDataKeys) Set(val *WebPushSubscriptionDataKeys) {
	v.value = val
	v.isSet = true
}

func (v NullableWebPushSubscriptionDataKeys) IsSet() bool {
	return v.isSet
}

func (v *NullableWebPushSubscriptionDataKeys) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWebPushSubscriptionDataKeys(val *WebPushSubscriptionDataKeys) *NullableWebPushSubscriptionDataKeys {
	return &NullableWebPushSubscriptionDataKeys{value: val, isSet: true}
}

func (v NullableWebPushSubscriptionDataKeys) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWebPushSubscriptionDataKeys) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


